unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileCtrl, StdCtrls;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Load_Folder: TButton;
    Extract: TButton;
    Label1: TLabel;
    V1: TLabel;
    V2: TLabel;
    Label2: TLabel;
    Optimised: TButton;
    procedure Load_FolderClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExtractClick(Sender: TObject);
    procedure OptimisedClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  Files : TStringList;
implementation

{$R *.dfm}

//----------------------------------------------------------------------------
// Uses 'FileCtrl' for SelectDirectory() function
//----------------------------------------------------------------------------
Procedure FindFiles(const Path, Mask:string; SubDir:Boolean; Files:TStringList );
var
  SearchRec : TSearchRec;
  sDir : String;
begin
  if FindFirst(Path + Mask, faAnyFile-faDirectory, SearchRec)=0 then
  begin
    repeat
      Files.Add(Path + searchRec.Name);
    until FindNext(searchRec) <> 0;
  end;

  if not SubDir then
  begin
    FindClose(SearchRec);
    Exit;
  end;

  sDir := IncludeTrailingPathDelimiter(Path);
  if FindFirst(Path + Mask, faDirectory, SearchRec)=0 then
  begin
    repeat
      if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
      begin
        if SearchRec.Attr and faDirectory = faDirectory then
        begin
          FindFiles (sDir + SearchRec.Name + '\', Mask, SubDir, Files);
        end;
      end;

    until FindNext(searchRec) <> 0;
  end;
  FindClose(SearchRec);
end;

//----------------------------------------------------------------------------
procedure TMainForm.Load_FolderClick(Sender: TObject);
var
  Dir : String;
begin
  Files.Clear;
  Memo1.Clear;

  if SelectDirectory('Select a folder:', GetCurrentDir+'\data', Dir) then
    //ShowMessage('You selected ' + Dir)
  else begin
    ShowMessage('You did not select a folder');
    Exit;
  end;

  Dir := Dir + '\';
  FindFiles(Dir, '*.*', true, Files);

  Memo1.Clear;
  Memo1.Lines.Add('Loaded folder: '+ Dir);
  Memo1.Lines.Add('Total files: '+ IntToStr(Files.Count));
  V1.Caption := '0/'+ IntToStr(Files.Count);
  V2.Caption := '0/'+ IntToStr(Files.Count);
end;

//----------------------------------------------------------------------------
procedure TMainForm.ExtractClick(Sender: TObject);
var
  rFile : TextFile;
  rawFile : TextFile;
  path : string;
  I, ai, bi, ci, x : Integer;
  time, a, b, c, i1, i2  : Double;
  max_a, max_a_b, max_a_c : Integer;
  max_b, max_b_a, max_b_c : Integer;
  max_c, max_c_a, max_c_b : Integer;
  min_a, min_a_b, min_a_c : Integer;
  min_b, min_b_a, min_b_c : Integer;
  min_c, min_c_a, min_c_b : Integer;
  z_a, z_a_b, z_a_c : Integer;
  z_b, z_b_a, z_b_c : Integer;
  z_c, z_c_a, z_c_b : Integer;
  z150_a, z150_a_b, z150_a_c : Integer;
  z150_b, z150_b_a, z150_b_c : Integer;
  z150_c, z150_c_a, z150_c_b : Integer;
  r1, r2 : Double;
  count : Integer;
  ffound : boolean;
  za, zb, zc, ca, cb, cc : Boolean;
  grid : Boolean;

begin
  x := 0;
  AssignFile(rawFile, 'Raw_Variable.txt');
  ReWrite(rawFile);
  for I:=0 to Files.Count-1 do begin
    count := 0;
    x := x + 1;
    V1.Caption := IntToStr(x) +' / '+ IntToStr(Files.Count);
    Application.ProcessMessages;

    path := Files.Strings[I];
    AssignFile(rFile, path);
    Reset(rFile);
    ffound := false;
    za := false;
    zb := false;
    zc := false;
    ca := false;
    cb := false;
    cc := false;

    ReadLn(rFile, time, a, b, c, i1, i2);
    if(a<b) then begin
      grid := true;
    end
    else begin
      grid := false;
    end;

    if (grid) then begin
      ai := Round(b);
      bi := Round(a);
    end
    else begin
      ai := Round(a);
      bi := Round(b);
    end;
    ci := Round(c);

    max_a := ai;
    max_a_b := bi;
    max_a_c := ci;
    max_b := bi;
    max_b_a := ai;
    max_b_c := ci;
    max_c := ci;
    max_c_a := ai;
    max_c_b := bi;
    min_a := ai;
    min_a_b := bi;
    min_a_c := ci;
    min_b := bi;
    min_b_a := ai;
    min_b_c := ci;
    min_c := ci;
    min_c_a := ai;
    min_c_b := bi;
    z_a := 0;
    z_a_b := 0;
    z_a_c := 0;
    z_b := 0;
    z_b_a := 0;
    z_b_c := 0;
    z_c := 0;
    z_c_a := 0;
    z_c_b := 0;
    z150_a := 0;
    z150_a_b := 0;
    z150_a_c := 0;
    z150_b := 0;
    z150_b_a := 0;
    z150_b_c := 0;
    z150_c := 0;
    z150_c_a := 0;
    z150_c_b := 0;
    r1 := i1;
    r2 := i2;

    while not eof(rFile) do begin
      ReadLn(rFile, time, a, b, c, i1, i2);
      if (grid) then begin
        ai := Round(b);
        bi := Round(a);
      end
      else begin
        ai := Round(a);
        bi := Round(b);
      end;
      ci := Round(c);

      if( (ffound=false) AND (i1>1.0E-18) ) then begin
        ffound := true;
      end;

      if( (ffound) AND (count<=38) ) then begin
        count := count + 1;
        if (max_a<ai) then begin
          max_a   := ai;
          max_a_b := bi;
          max_a_c := ci;
        end;
        if (max_b<bi) then begin
          max_b   := bi;
          max_b_a := ai;
          max_b_c := ci;
        end;
        if (max_c<ci) then begin
          max_c   := ci;
          max_c_a := ai;
          max_c_b := bi;
        end;
        if (min_a>ai) then begin
          min_a   := ai;
          min_a_b := bi;
          min_a_c := ci;
        end;
        if (min_b>bi) then begin
          min_b   := bi;
          min_b_a := ai;
          min_b_c := ci;
        end;
        if (min_c>ci) then begin
          min_c   := ci;
          min_c_a := ai;
          min_c_b := bi;
        end;
        if (r1<i1) then begin
          r1 := i1;
        end;
        if (r2<i2) then begin
          r2 := i2;
        end;

        if( (ai>150) AND (ca=false) ) then begin
          z150_a   := ai;
          z150_a_b := bi;
          z150_a_c := ci ;
          ca := true;
        end;
        if( (bi>-150) AND (cb=false) ) then begin
          z150_b   := bi;
          z150_b_a := ai;
          z150_b_c := ci;
          cb := true;
        end;
        if( (ci>150) AND (cc=false) ) then begin
          z150_c   := ci;
          z150_c_a := ai;
          z150_c_b := bi;
          cc := true;
        end;

        if (ai<0) then begin
          z_a   := ai;
          z_a_b := bi;
          z_a_c := ci ;
        end;
        if (bi>0) then begin
          z_b   := bi;
          z_b_a := ai;
          z_b_c := ci;
        end;
        if (ci<0) then begin
          z_c   := ci;
          z_c_a := ai;
          z_c_b := bi;
        end;
        if( (ai<0) OR (bi>0) OR (ci<0) ) then begin
          break;
        end;


      end;
    end;
    CloseFile(rFile);

    Write(rawFile, StringReplace(ExtractFileName(Files.Strings[I]), '.txt', '', [rfReplaceAll, rfIgnoreCase]):25);

    Write(rawFile, max_a:5);    // X1
    Write(rawFile, max_a_b:5);
    Write(rawFile, max_a_c:5);
    Write(rawFile, max_b:5);
    Write(rawFile, max_b_a:5);  // X5
    Write(rawFile, max_b_c:5);
    Write(rawFile, max_c:5);
    Write(rawFile, max_c_a:5);
    Write(rawFile, max_c_b:5);
    Write(rawFile, min_a:5);    // X10
    Write(rawFile, min_a_b:5);
    Write(rawFile, min_a_c:5);
    Write(rawFile, min_b:5);
    Write(rawFile, min_b_a:5);
    Write(rawFile, min_b_c:5);  // X15
    Write(rawFile, min_c:5);
    Write(rawFile, min_c_a:5);
    Write(rawFile, min_c_b:5);  // X18

    Write(rawFile, z_a:5);      // X19
    Write(rawFile, z_a_b:5);
    Write(rawFile, z_a_c:5);
    Write(rawFile, z_b:5);
    Write(rawFile, z_b_a:5);
    Write(rawFile, z_b_c:5);
    Write(rawFile, z_c:5);      // X25
    Write(rawFile, z_c_a:5);
    Write(rawFile, z_c_b:5);
    Write(rawFile, z150_a:5);   // X28
    Write(rawFile, z150_a_b:5);
    Write(rawFile, z150_a_c:5); // X30
    Write(rawFile, z150_b:5);
    Write(rawFile, z150_b_a:5);
    Write(rawFile, z150_b_c:5);
    Write(rawFile, z150_c:5);
    Write(rawFile, z150_c_a:5); // X35
    Write(rawFile, z150_c_b:5);

    Write(rawFile, r1:10);
    Write(rawFile, r2:10);      // X38

    WriteLn(rawFile);
  end;

  CloseFile(rawFile);
end;

//----------------------------------------------------------------------------
procedure TMainForm.OptimisedClick(Sender: TObject);
var
  rFile : TextFile;
  opFile : TextFile;
  path : string;
  I, ai, bi, ci, x : Integer;
  time, a, b, c, i1, i2  : Double;
  max_a, max_a_b, max_a_c : Integer;
  max_b, max_b_a, max_b_c : Integer;
  max_c, max_c_a, max_c_b : Integer;
  min_a, min_a_b, min_a_c : Integer;
  min_b, min_b_a, min_b_c : Integer;
  min_c, min_c_a, min_c_b : Integer;
  z_a, z_a_b, z_a_c : Integer;
  z_b, z_b_a, z_b_c : Integer;
  z_c, z_c_a, z_c_b : Integer;
  z150_a, z150_a_b, z150_a_c : Integer;
  z150_b, z150_b_a, z150_b_c : Integer;
  z150_c, z150_c_a, z150_c_b : Integer;
  r1, r2 : Double;
  count : Integer;
  ffound : boolean;
  za, zb, zc, ca, cb, cc : Boolean;
  grid : Boolean;

begin
  x := 0;
  AssignFile(opFile, 'Optimised_Variable.txt');
  ReWrite(opFile);
  for I:=0 to Files.Count-1 do begin
    count := 0;
    x := x + 1;
    V2.Caption := IntToStr(x) +' / '+ IntToStr(Files.Count);
    Application.ProcessMessages;

    path := Files.Strings[I];
    AssignFile(rFile, path);
    Reset(rFile);
    ffound := false;
    za := false;
    zb := false;
    zc := false;
    ca := false;
    cb := false;
    cc := false;

    ReadLn(rFile, time, a, b, c, i1, i2);
    if(a<b) then begin
      grid := true;
    end
    else begin
      grid := false;
    end;

    if (grid) then begin
      ai := Round(b);
      bi := Round(a);
    end
    else begin
      ai := Round(a);
      bi := Round(b);
    end;
    ci := Round(c);

    max_a := ai;
    max_a_b := bi;
    max_a_c := ci;
    max_b := bi;
    max_b_a := ai;
    max_b_c := ci;
    max_c := ci;
    max_c_a := ai;
    max_c_b := bi;
    min_a := ai;
    min_a_b := bi;
    min_a_c := ci;
    min_b := bi;
    min_b_a := ai;
    min_b_c := ci;
    min_c := ci;
    min_c_a := ai;
    min_c_b := bi;
    z_a := 0;
    z_a_b := 0;
    z_a_c := 0;
    z_b := 0;
    z_b_a := 0;
    z_b_c := 0;
    z_c := 0;
    z_c_a := 0;
    z_c_b := 0;
    z150_a := 0;
    z150_a_b := 0;
    z150_a_c := 0;
    z150_b := 0;
    z150_b_a := 0;
    z150_b_c := 0;
    z150_c := 0;
    z150_c_a := 0;
    z150_c_b := 0;
    r1 := i1;
    r2 := i2;

    while not eof(rFile) do begin
      ReadLn(rFile, time, a, b, c, i1, i2);
      if (grid) then begin
        ai := Round(b);
        bi := Round(a);
      end
      else begin
        ai := Round(a);
        bi := Round(b);
      end;
      ci := Round(c);

      if( (ffound=false) AND (i1>1.0E-18) ) then begin
        ffound := true;
      end;

      if( (ffound) AND (count<=38) ) then begin
        count := count + 1;
        if (max_a<ai) then begin
          max_a   := ai;
          max_a_b := bi;
          max_a_c := ci;
        end;
        if (max_b<bi) then begin
          max_b   := bi;
          max_b_a := ai;
          max_b_c := ci;
        end;
        if (max_c<ci) then begin
          max_c   := ci;
          max_c_a := ai;
          max_c_b := bi;
        end;
        if (min_a>ai) then begin
          min_a   := ai;
          min_a_b := bi;
          min_a_c := ci;
        end;
        if (min_b>bi) then begin
          min_b   := bi;
          min_b_a := ai;
          min_b_c := ci;
        end;
        if (min_c>ci) then begin
          min_c   := ci;
          min_c_a := ai;
          min_c_b := bi;
        end;
        if (r1<i1) then begin
          r1 := i1;
        end;
        if (r2<i2) then begin
          r2 := i2;
        end;

        if( (ai>150) AND (ca=false) ) then begin
          z150_a   := ai;
          z150_a_b := bi;
          z150_a_c := ci ;
          ca := true;
        end;
        if( (bi>-150) AND (cb=false) ) then begin
          z150_b   := bi;
          z150_b_a := ai;
          z150_b_c := ci;
          cb := true;
        end;
        if( (ci>150) AND (cc=false) ) then begin
          z150_c   := ci;
          z150_c_a := ai;
          z150_c_b := bi;
          cc := true;
        end;

        if (ai<0) then begin
          z_a   := ai;
          z_a_b := bi;
          z_a_c := ci ;
        end;
        if (bi>0) then begin
          z_b   := bi;
          z_b_a := ai;
          z_b_c := ci;
        end;
        if (ci<0) then begin
          z_c   := ci;
          z_c_a := ai;
          z_c_b := bi;
        end;
        if( (ai<0) OR (bi>0) OR (ci<0) ) then begin
          break;
        end;


      end;
    end;
    CloseFile(rFile);

    Write(opFile, StringReplace(ExtractFileName(Files.Strings[I]), '.txt', '', [rfReplaceAll, rfIgnoreCase]):25);

    Write(opFile, max_a:5);    // X1
    Write(opFile, max_a_b:5);
    Write(opFile, max_a_c:5);
    Write(opFile, max_b:5);
    Write(opFile, max_b_a:5);  // X5
    Write(opFile, max_b_c:5);  // X6


    Write(opFile, z_a:5);      // X7
    Write(opFile, z_a_b:5);
    Write(opFile, z_a_c:5);
    Write(opFile, z_b:5);      // X10
    Write(opFile, z_b_a:5);
    Write(opFile, z_b_c:5);
    Write(opFile, z_c:5);
    Write(opFile, z_c_a:5);
    Write(opFile, z_c_b:5);    // X15
    Write(opFile, z150_a:5);
    Write(opFile, z150_a_b:5);
    Write(opFile, z150_a_c:5);
    Write(opFile, z150_b:5);
    Write(opFile, z150_b_a:5); // X20
    Write(opFile, z150_b_c:5);
    Write(opFile, z150_c:5);
    Write(opFile, z150_c_a:5);
    Write(opFile, z150_c_b:5);

    Write(opFile, r1:10);      // X25
    Write(opFile, r2:10);

    WriteLn(opFile);
  end;

  CloseFile(opFile);
end;

//----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
begin
  Files := TStringList.Create;
  V1.Caption := '0/0';
  V2.Caption := '0/0';
end;

//----------------------------------------------------------------------------
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Files.Free;
end;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
end.
